.\" file MASS/area.d
.\" copyright (C) 1994-9 W. N. Venables and B. D. Ripley
.\"
.BG
.FN area
.TL
Adaptive Numerical Integration
.DN
Integrate a function of one variable over a finite range using a
recursive adaptive method.  This function is mainly for
demonstration purposes. 
.CS
area(f, a, b, ..., fa=f(a, ...), fb=f(b, ...), 
     limit=10, eps=100 * .Machine$single.eps)
.RA
.AG f
The integrand as an `S' function object.  The variable of integration must be
the first argument.
.AG a
Lower limit of integration.
.AG b
Upper limit of integration.
.OA
.AG ...
Additional arguments needed by the integrand.
.AG fa
Function value at the lower limit.
.AG fb
Function value at the upper limit.
.AG limit
Limit on the depth to which recursion is allowed to go.
.AG eps
Error tolerance to control the process.
.RT
The integral from `a' to `b' of `f(x)'.
.DT
The method divides the interval in two and compares the values given by
Simpson's rule and the trapezium rule.  If these are within eps of each
other the Simpson's rule result is given, otherwise the process is applied
separately to each half of the interval and the results added together.
.SA
`integrate'
.EX
area(sin, 0, pi)  # integrate the sin function from 0 to pi.
.KW nonlinear
.WR
