.\" file MASS/mca.d
.\" copyright (C) 1994-9 W. N. Venables and B. D. Ripley
.\"
.BG
.FN mca
.TL
Multiple Correspondence Analysis
.DN
Computes a multiple correspondence analysis of a set of factors.
.CS
mca(df, nf=2, abbrev=F)
.RA
.AG df
A data frame containing only factors
.OA
.AG nf
The number of dimensions for the MCA. Rarely 3 might be useful.
.AG abbrev
Should the vertex names be abbreviated?  By default these are of the
form ``factor.level'' but if `abbrev=T' they are just ``level'' which will
suffice if the factors have distinct levels.
.RT
An object of class `"mca"', with components
.RC rs
The coordinates of the rows, in `nf' dimensions.
.RC cs
The coordinates of the column vertices, one for each level of each factor.
.RC fs
Weights for each row, used to interpolate additional factors in `predict.mca'.
.RC p
The number of factors
.RC d
The singular values for the `nf' dimensions.
.RC call
The matched call.
.SA
`predict.mca', `plot.mca', `corresp'
.EX
farms.mca <- mca(farms, abbrev=T)
farms.mca
plot(farms.mca)
.KW category
.KW multivariate
.WR
