C
C     Modified from the SMART package by J.H. Friedman, 10/10/84
C     Main change is to add spline smoothing modified from BRUTO,
C     calling code written for smooth.spline in S.
C
C     B.D. Ripley (ripley@stats.ox.ac.uk)  1994-7.
C
C
      subroutine BDRsmart(m,mu,p,q,n,w,x,y,ww,smod,nsmod,
     & sp,nsp,dp,ndp,edf)
      implicit double precision (a-h, o-z)
      integer p,q
      double precision x(p,n),y(q,n),w(n),ww(q),smod(nsmod),
     & sp(nsp),edf(m)
      double precision dp(ndp)
      smod(1)=m
      smod(2)=p
      smod(3)=q
      smod(4)=n
      call BDRsmart1(m,mu,p,q,n,w,x,y,ww,smod(6),smod(q+6),smod(q+7),
     & smod(q+7+p*m),smod(q+7+m*(p+q)),smod(q+7+m*(p+q+n)),  
     & smod(q+7+m*(p+q+2*n)),sp,sp(q*n+1),sp(n*(q+15)+1),  
     & sp(n*(q+15)+q+1),dp,smod(5),edf)
      return
      end

      subroutine BDRsmart1(m,mu,p,q,n,w,x,y,ww,yb,ys,a,b,f,t,
     & asr,r,sc,bt,g,dp,flm,edf)
      implicit double precision (a-h, o-z)
      integer p,q
      double precision w(n),x(p,n),y(*),ww(q),a(p,m),f(n,m),t(n,m),
     & r(q,n)
      double precision sc(n,15),g(p,3),yb(q),b(q,m),bt(q),edf(m)
      double precision dp(*)
      common /BDRparms/ ifl,lf,span,alpha,big
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj
      sw=0d0
      do 10161 j=1,n
10161   sw=sw+w(j)
      do 10201 j=1,n
        do 10201 i=1,q
10201     r(i,j)=y(q*(j-1)+i)
      do 10241 i=1,q
        s=0d0
        do 10251 j=1,n
10251     s=s+w(j)*r(i,j)
        yb(i)=s/sw
10241   continue
c     yb is vector of means
      do 10261 j=1,n
        do 10261 i=1,q
10261     r(i,j)=r(i,j)-yb(i)
      ys=0.
      do 10281 i=1,q
        s=0.
        do 10291 j=1,n
10291     s=s+w(j)*r(i,j)**2
10281   ys=ys+ww(i)*s/sw
      if(ys .gt. 0d0) goto 10311
c     ys is the overall standard deviation -- quit if zero
      return
10311 continue
      ys=sqrt(ys)
      s=1./ys
      do 10331 j=1,n
        do 10331 i=1,q
10331     r(i,j)=r(i,j)*s
c     r is now standardized residuals
c     subfit adds up to m  terms one at time; lm is the number fitted.
      call BDRsubfit(m,p,q,n,w,sw,x,r,ww,lm,a,b,f,t,asr,sc,bt,g,dp,edf)
      if(lf.le.0) go to 10350
      call BDRfulfit(lm,lf,p,q,n,w,sw,x,r,ww,a,b,f,t,asr,sc,bt,g,dp,edf)
10371 continue
      do 10381 l=1,lm
        sc(l,1)=l+.1
        s=0d0
        do 10391 i=1,q
10391     s=s+ww(i)*abs(b(i,l))
10381   sc(l,2)=-s
      call BDRsort(sc(1,2),sc,1,lm)
      do 10461 j=1,n
        do 10461 i=1,q
10461     r(i,j)=y(q*(j-1)+i)
      do 10521 i=1,q
        do 10531 j=1,n
          r(i,j)=r(i,j)-yb(i)
          s=0.
          do 10541 l=1,lm
10541       s=s+b(i,l)*f(j,l)
          r(i,j)=r(i,j)/ys-s
10531     continue
10521   continue
      if(lm.le.mu) goto 10350
      l=sc(lm,1)
      asr=0d0
      do 10561 j=1,n
        do 10561 i=1,q
          r(i,j)=r(i,j)+b(i,l)*f(j,l)
10561     asr=asr+w(j)*ww(i)*r(i,j)**2
      asr=asr/sw
      if(l .ge. lm) goto 10591
      do 10601 i=1,p
10601   a(i,l)=a(i,lm)
      do 10611 i=1,q
10611   b(i,l)=b(i,lm)
      do 10621 j=1,n
        f(j,l)=f(j,lm)
10621   t(j,l)=t(j,lm)
10591 continue
      lm=lm-1
      call BDRfulfit(lm,lf,p,q,n,w,sw,x,r,ww,a,b,f,t,asr,sc,bt,g,dp,edf)
      goto 10371
10350 continue
      flm=lm
      return
      end

      subroutine BDRsubfit(m,p,q,n,w,sw,x,r,ww,lm,a,b,f,t,asr,sc,
     & bt,g,dp,edf)
      implicit double precision (a-h, o-z)
      integer p,q
      double precision w(n),x(p,n),ww(q),a(p,m),f(n,m),t(n,m),r(q,n)
      double precision sc(n,15),g(p,3),b(q,m),bt(q),edf(m)
      double precision dp(*)

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big

      double precision conv,cutmin,fdel,cjeps
      integer maxit,mitone,mitcj
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj

      asr=big
      lm=0
      do 10641 l=1,m
        lm=lm+1
        asrold=asr
        call BDRnewb(lm,q,ww,b)
        call BDRonetrm(0,p,q,n,w,sw,x,r,ww,a(1,lm),b(1,lm),
     &    f(1,lm),t(1,lm),asr,sc,g,dp,edf)
        do 10651 j=1,n
          do 10651 i=1,q
10651       r(i,j)=r(i,j)-b(i,lm)*f(j,lm)
      if(lm.eq.1) goto 10641
      if(lf.le.0) goto 10690
      if(lm.eq.m) return
      iflsv=ifl
      ifl=0
      call BDRfulfit(lm,1,p,q,n,w,sw,x,r,ww,a,b,f,t,asr,sc,bt,g,dp,edf)
      ifl=iflsv
10690 continue
      if(asr.le.0d0.or.(asrold-asr)/asrold.lt.conv) return
10641 continue
      return
      end

      subroutine BDRfulfit(lm,lbf,p,q,n,w,sw,x,r,ww,a,b,f,t,
     & asr,sc,bt,g,dp,edf)
      implicit double precision (a-h, o-z)
      integer p,q
      double precision w(n),x(p,n),ww(q),a(p,lm),f(n,lm),t(n,lm),r(q,n)
      double precision sc(n,15),g(p,3),b(q,lm),bt(q),asr(1+lm),edf(lm)
      double precision dp(*)

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big


      double precision conv,cutmin,fdel,cjeps
      integer maxit,mitone,mitcj
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj

      if(lbf.le.0) return
      asri=asr(1)
      iter=0
      fsv=cutmin
      isv=mitone
      if(lbf .ge. 3) goto 10711
      cutmin=1d0
      mitone=lbf-1
10711 continue
      asrold=asri
      iter=iter+1
      do 10731 lp=1,lm
        do 10741 i=1,q
10741     bt(i)=b(i,lp)
        do 10751 i=1,p
10751     g(i,3)=a(i,lp)
        do 10761 j=1,n
          do 10761 i=1,q
10761       r(i,j)=r(i,j)+bt(i)*f(j,lp)
        call BDRonetrm(1,p,q,n,w,sw,x,r,ww,g(1,3),bt,sc(1,14),sc(1,15),
     &    asri,sc,g,dp,edf(lp))
        if(asri .lt. asrold) then
        do 10801 i=1,q
10801     b(i,lp)=bt(i)
        do 10811 i=1,p
10811     a(i,lp)=g(i,3)
        do 10821 j=1,n
          f(j,lp)=sc(j,14)
10821     t(j,lp)=sc(j,15)
        else
           asri=asrold
        endif
        do 10841 j=1,n
          do 10841 i=1,q
10841       r(i,j)=r(i,j)-b(i,lp)*f(j,lp)
10731   continue
      if((iter .le. maxit) .and. ((asri .gt. 0d0) .and. 
     & ((asrold-asri)/asrold .ge. conv))) goto 10711
      cutmin=fsv
      mitone=isv
      if(ifl .le. 0) goto 10871
      asr(1+lm) = asri
      asr(1) = asri
10871 continue
      return
      end

      subroutine BDRonetrm(jfl,p,q,n,w,sw,x,y,ww,a,b,f,t,asr,
     & sc,g,dp,edf)
      implicit double precision (a-h, o-z)
      integer p,q
      double precision w(n),x(p,n),y(q,n),ww(q),a(p),b(q),f(n),t(n)
      double precision sc(n,13),g(p,2)
      double precision dp(*)

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big

      double precision conv,cutmin,fdel,cjeps
      integer maxit,mitone,mitcj
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj

      iter=0
      asr=big
10901 continue
      iter=iter+1
      asrold=asr
      do 10911 j=1,n
        s=0d0
        do 10921 i=1,q
10921     s=s+ww(i)*b(i)*y(i,j)
10911   sc(j,13)=s
      call BDRoneone(max0(jfl,iter-1),p,n,w,sw,sc(1,13),x,a,f,t,
     & asr,sc,g,dp,edf)
      do 10931 i=1,q
        s=0d0
        do 10941 j=1,n
10941     s=s+w(j)*y(i,j)*f(j)
10931   b(i)=s/sw
      asr=0d0
      do 10951 i=1,q
        s=0d0
        do 10961 j=1,n
10961     s=s+w(j)*(y(i,j)-b(i)*f(j))**2
10951   asr=asr+ww(i)*s/sw
      if((q .ne. 1) .and. ((iter .le. maxit) .and. ((asr .gt. 0d0) 
     & .and. ((asrold-asr)/asrold .ge. conv)))) goto 10901
      return
      end

      subroutine BDRoneone(ist,p,n,w,sw,y,x,a,f,t,asr,sc,g,dp,edf)
      implicit double precision (a-h, o-z)
      integer p
      double precision w(n),y(n),x(p,n),a(p),f(n),t(n),sc(n,12),g(p,2)
      double precision dp(*)

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big

      double precision conv,cutmin,fdel,cjeps
      integer maxit,mitone,mitcj
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj
      sml=1d0/big
      if(ist .gt. 0) goto 10981
      if(p .gt. 1) goto 11001
      a(1)=1d0
      goto 11011
11001 continue
      do 11021 j=1,n
        sc(j,2)=1d0
11021   continue
      call BDRdir(p,n,w,sw,y,x,sc(1,2),a,dp)
11011 continue
10981 continue
      s=0d0
      do 11031 i=1,p
        g(i,1)=0d0
        s=s+a(i)**2
11031   continue
      s=1d0/sqrt(s)
      do 11041 i=1,p
        a(i)=a(i)*s
11041   continue
      iter=0
      asr=big
      cut=1d0
11051 continue
      iter=iter+1
      asrold=asr
11060 continue
      s=0d0
      do 11071 i=1,p
        g(i,2)=a(i)+g(i,1)
        s=s+g(i,2)**2
11071 continue
      s=1./sqrt(s)
      do 11081 i=1,p
        g(i,2)=g(i,2)*s
11081   continue
      do 11091 j=1,n
        sc(j,1)=j+.1
        s=0.
        do 11101 i=1,p
          s=s+g(i,2)*x(i,j)
11101     continue
        sc(j,11)=s
11091   continue
      call BDRsort(sc(1,11),sc,1,n)
      do 11111 j=1,n
        k=sc(j,1)
        sc(j,2)=y(k)
        sc(j,3)=max(w(k),sml)
11111   continue
      call BDRsupsmu(n,sc(1,11),sc(1,2),sc(1,3),1,span,alpha,
     & sc(1,12),sc(1,4), edf)
      s=0d0
      do 11121 j=1,n
        s=s+sc(j,3)*(sc(j,2)-sc(j,12))**2
11121   continue
      s=s/sw
      if(s .lt. asr) goto 11141
      cut=cut*0.5
      if(cut.lt.cutmin) goto 11052
      do 11151 i=1,p
        g(i,1)=g(i,1)*cut
11151   continue
      go to 11060
11141 continue
      asr=s
      cut=1d0
      do 11161 i=1,p
        a(i)=g(i,2)
11161   continue
      do 11171 j=1,n
        k=sc(j,1)
        t(k)=sc(j,11)
        f(k)=sc(j,12)
11171   continue
      if(asr.le.0d0.or.(asrold-asr)/asrold.lt.conv) goto 11052
      if(iter.gt.mitone.or.p.le.1) goto 11052
      call BDRder(n,sc(1,11),sc(1,12),sc(1,3),fdel,sc(1,4),sc(1,5))
      do 11181 j=1,n
        k=sc(j,1)
        sc(j,5)=y(j)-f(j)
        sc(k,6)=sc(j,4)
11181   continue
      call BDRdir(p,n,w,sw,sc(1,5),x,sc(1,6),g,dp)
      goto 11051
11052 continue
      s=0d0
      v=s
      do 11191 j=1,n
        s=s+w(j)*f(j)
11191   continue
      s=s/sw
      do 11201 j=1,n
        f(j)=f(j)-s
        v=v+w(j)*f(j)**2
11201   continue
      if(v .le. 0d0) goto 11221
      v=1d0/sqrt(v/sw)
      do 11231 j=1,n
11231   f(j)=f(j)*v
11221 continue
      return
      end


      subroutine BDRdir(p,n,w,sw,r,x,d,e,g)
      implicit double precision (a-h, o-z)
      integer p
      double precision w(n),r(n),x(p,n),d(n),e(p)
      double precision s,g(*)

      double precision conv,cutmin,fdel,cjeps
      integer maxit,mitone,mitcj
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj

      do 11241 i=1,p
      s=0d0
      do 11251 j=1,n
      s=s+w(j)*d(j)*x(i,j)
11251 continue
      e(i)=s/sw
11241 continue
      k=0
      m1=p*(p+1)/2
      m2=m1+p
      do 11261 j=1,p
      s=0d0
      do 11271 l=1,n
      s=s+w(l)*r(l)*(d(l)*x(j,l)-e(j))
11271 continue
      g(m1+j)=s/sw
      do 11281 i=1,j
      s=0d0
      do 11291 l=1,n
      s=s+w(l)*(d(l)*x(i,l)-e(i))*(d(l)*x(j,l)-e(j))
11291 continue
      k=k+1
      g(k)=s/sw
11281 continue
11261 continue
      call BDRconj(p,g,g(m1+1),g(m2+1),cjeps,mitcj,g(m2+p+1))
      do 11301 i=1,p
      e(i)=g(m2+i)
11301 continue
      return
      end

      subroutine BDRconj(p,g,c,x,eps,maxit,sc)
      implicit double precision (a-h, o-z)
      integer p
      double precision g(*),c(p),x(p),sc(p,4)
      double precision beta,h,s,alpha,t
      do 11311 i=1,p
      x(i)=0d0
      sc(i,2)=0d0
11311 continue
      nit=0
11321 continue
      nit=nit+1
      h=0d0
      beta=0d0
      do 11331 i=1,p
      sc(i,4)=x(i)
      s=g(i*(i-1)/2+i)*x(i)
      im1=i-1
      j=1
      goto 11343
11341 j=j+1
11343 if((j).gt.(im1)) goto 11342
      s=s+g(i*(i-1)/2+j)*x(j)
      goto 11341
11342 continue
      j=i+1
      goto 11353
11351 j=j+1
11353 if((j).gt.(p)) goto 11352
      s=s+g(j*(j-1)/2+i)*x(j)
      goto 11351
11352 continue
      sc(i,1)=s-c(i)
      h=h+sc(i,1)**2
11331 continue
      if(h.le.0d0) goto 11322
      do 11361 iter=1,p
      do 11371 i=1,p
      sc(i,2)=beta*sc(i,2)-sc(i,1)
11371 continue
      t=0d0
      do 11381 i=1,p
      s=g(i*(i-1)/2+i)*sc(i,2)
      im1=i-1
      j=1
      goto 11393
11391 j=j+1
11393 if((j).gt.(im1)) goto 11392
      s=s+g(i*(i-1)/2+j)*sc(j,2)
      goto 11391
11392 continue
      j=i+1
      goto 11403
11401 j=j+1
11403 if((j).gt.(p)) goto 11402
      s=s+g(j*(j-1)/2+i)*sc(j,2)
      goto 11401
11402 continue
      sc(i,3)=s
      t=t+s*sc(i,2)
11381 continue
      alpha=h/t
      s=0d0
      do 11411 i=1,p
      x(i)=x(i)+alpha*sc(i,2)
      sc(i,1)=sc(i,1)+alpha*sc(i,3)
      s=s+sc(i,1)**2
11411 continue
      if(s.le.0d0) goto 11362
      beta=s/h
      h=s
11361 continue
11362 continue
      s=0d0
      do 11421 i=1,p
      s=dmax1(s,dabs(x(i)-sc(i,4)))
11421 continue
      if((s .ge. eps) .and. (nit .lt. maxit)) goto 11321
11322 continue
      return
      end

      subroutine BDRder (n,x,s,w,fdel,d,sc)
      implicit double precision (a-h, o-z)
      double precision x(n),s(n),w(n),d(n),sc(n,3)
      integer bl,el,bc,ec,br,er
      if(x(n) .gt. x(1)) goto 11441
      do 11451 j=1,n
      d(j)=0d0
11451 continue
      return
11441 continue
      i=n/4
      j=3*i
      scale=x(j)-x(i)
11461 if(scale.gt.0d0) goto 11462
      if(j.lt.n) j=j+1
      if(i.gt.1) i=i-1
      scale=x(j)-x(i)
      goto 11461
11462 continue
      del=fdel*scale*2.0d0
      do 11471 j=1,n
      sc(j,1)=x(j)
      sc(j,2)=s(j)
      sc(j,3)=w(j)
11471 continue
      call BDRpool (n,sc,sc(1,2),sc(1,3),del)
      bc=0
      br=bc
      er=br
11481 continue
      br=er+1
      er=br
11491 if(er .ge. n) goto 11492
      if(sc(br,1) .ne. sc(er+1,1)) goto 11511
      er=er+1
      goto 11521
11511 continue
      goto 11492
11521 continue
11501 continue
      goto 11491
11492 continue
      if(br .ne. 1) goto 11541
      bl=br
      el=er
      goto 11481
11541 continue
      if(bc .ne. 0) goto 11561
      bc=br
      ec=er
      do 11571 j=bl,el
      d(j)=(sc(bc,2)-sc(bl,2))/(sc(bc,1)-sc(bl,1))
11571 continue
      goto 11481
11561 continue
      do 11581 j=bc,ec
      d(j)=(sc(br,2)-sc(bl,2))/(sc(br,1)-sc(bl,1))
11581 continue
      if(er .ne. n) goto 11601
      do 11611 j=br,er
      d(j)=(sc(br,2)-sc(bc,2))/(sc(br,1)-sc(bc,1))
11611 continue
      goto 11482
11601 continue
      bl=bc
      el=ec
      bc=br
      ec=er
      goto 11481
11482 continue
      return
      end

      subroutine BDRpool (n,x,y,w,del)
      implicit double precision (a-h, o-z)
      double precision x(n),y(n),w(n)
      integer bb,eb,br,er,bl,el
      bb=0
      eb=bb
11621 if(eb.ge.n) goto 11622
      bb=eb+1
      eb=bb
11631 if(eb .ge. n) goto 11632
      if(x(bb) .ne. x(eb+1)) goto 11651
      eb=eb+1
      goto 11661
11651 continue
      goto 11632
11661 continue
11641 continue
      goto 11631
11632 continue
      if(eb .ge. n) goto 11681
      if(x(eb+1)-x(eb) .ge. del) goto 11701
      br=eb+1
      er=br
11711 if(er .ge. n) goto 11712
      if(x(er+1) .ne. x(br)) goto 11731
      er=er+1
      goto 11741
11731 continue
      goto 11712
11741 continue
11721 continue
      goto 11711
11712 continue
      if(er.lt.n .and. x(er+1)-x(er).lt.x(eb+1)-x(eb)) goto 11621
      eb=er
      pw=w(bb)+w(eb)
      px=(x(bb)*w(bb)+x(eb)*w(eb))/pw
      py=(y(bb)*w(bb)+y(eb)*w(eb))/pw
      do 11751 i=bb,eb
      x(i)=px
      y(i)=py
      w(i)=pw
11751 continue
11701 continue
11681 continue
11761 continue
      if(bb.le.1) goto 11762
      if(x(bb)-x(bb-1).ge.del) goto 11762
      bl=bb-1
      el=bl
11771 if(bl .le. 1) goto 11772
      if(x(bl-1) .ne. x(el)) goto 11791
      bl=bl-1
      goto 11801
11791 continue
      goto 11772
11801 continue
11781 continue
      goto 11771
11772 continue
      bb=bl
      pw=w(bb)+w(eb)
      px=(x(bb)*w(bb)+x(eb)*w(eb))/pw
      py=(y(bb)*w(bb)+y(eb)*w(eb))/pw
      do 11811 i=bb,eb
      x(i)=px
      y(i)=py
      w(i)=pw
11811 continue
      goto 11761
11762 continue
      goto 11621
11622 continue
      return
      end

      subroutine BDRnewb(lm,q,ww,b)
      implicit double precision (a-h, o-z)
      integer q
      double precision ww(q),b(q,lm)

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big

      sml=1d0/big
      if(q .ne. 1) goto 11831
      b(1,lm)=1d0
      return
11831 continue
      if(lm .ne. 1) goto 11851
      do 11861 i=1,q
      b(i,lm)=i
11861 continue
      return
11851 continue
      lm1=lm-1
      do 11871 i=1,q
      b(i,lm)=0d0
11871 continue
      t=0d0
      do 11881 i=1,q
      s=0d0
      do 11891 l=1,lm1
      s=s+abs(b(i,l))
11891 continue
      b(i,lm)=s
      t=t+s
11881 continue
      do 11901 i=1,q
      b(i,lm)=ww(i)*(t-b(i,lm))
11901 continue
      l1=1
      if(lm.gt.q) l1=lm-q+1
      do 11911 l=l1,lm1
      s=0d0
      t=s
      do 11921 i=1,q
      s=s+ww(i)*b(i,lm)*b(i,l)
      t=t+ww(i)*b(i,l)**2
11921 continue
      s=s/sqrt(t)
      do 11931 i=1,q
      b(i,lm)=b(i,lm)-s*b(i,l)
11931 continue
11911 continue
      do 11941 i=2,q
      if(abs(b(i-1,lm)-b(i,lm)).gt.sml) return
11941 continue
      do 11951 i=1,q
      b(i,lm)=i
11951 continue
      return
      end

      block data BDRbkppr
      implicit double precision (a-h, o-z)

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big

      double precision conv,cutmin,fdel,cjeps
      integer maxit,mitone,mitcj
      common /BDRz01/ conv,maxit,mitone,cutmin,fdel,cjeps,mitcj

      double precision df, gcvpen
      integer ismethod
      common /BDRspsmooth/ df, gcvpen, ismethod
      data ifl,maxit,conv,mitone,cutmin,fdel,span,alpha,big,cjeps,
     & mitcj, lf  /6,20,.005d0,20,0.1d0,0.02d0,0.0,0.0,1.0d20,
     & 0.001d0,1,2/
      data df, gcvpen, ismethod /4d0, 1d0, 0/
      end

      subroutine BDRsetppr(span1, alpha1, optlevel, ism, df1, 
     & gcvpen1)
      implicit double precision (a-h, o-z)
      integer optlevel
      double precision alpha1, df1, gcvpen1

      double precision span,alpha,big
      integer ifl,lf
      common /BDRparms/ ifl,lf,span,alpha,big

      double precision df, gcvpen
      integer ismethod
      common /BDRspsmooth/ df, gcvpen, ismethod

      span = span1
      lf = optlevel
      alpha = alpha1
      ismethod = ism
      df = df1
      gcvpen = gcvpen1
      return
      end

      subroutine BDRfsort(mu,n,f,t,sp)
      implicit double precision (a-h, o-z)
      double precision f(n,mu),t(n,mu),sp(n,2)
      do 12151 l=1,mu
      do 12161 j=1,n
      sp(j,1)=j+.1
      sp(j,2)=f(j,l)
12161 continue
      call BDRsort(t(1,l),sp,1,n)
      do 12171 j=1,n
      k=sp(j,1)
      f(j,l)=sp(k,2)
12171 continue
12151 continue
      return
      end
      

      subroutine BDRpred(np,x,smod,y,sc)
      implicit double precision (a-h, o-z)
      integer p,q
      double precision x(np,*),y(np,*),smod(*), sc(*)
      integer place,low,high
      m=smod(1)+.1
      p=smod(2)+.1
      q=smod(3)+.1
      n=smod(4)+.1
      mu=smod(5)+.1
      ys=smod(q+6)
      ja=q+6
      jb=ja+p*m
      jf=jb+m*q
      jt=jf+n*m
      call BDRfsort(mu,n,smod(jf+1),smod(jt+1),sc)
      do 100 inp = 1, np
      ja=q+6
      jb=ja+p*m
      jf=jb+m*q
      jt=jf+n*m      
      do 12181 i=1,q
      y(inp,i)=0d0
12181 continue
      do 12191 l=1,mu
      s=0d0
      do 12201 j=1,p
      s=s+smod(ja+j)*x(inp,j)
12201 continue
      if(s .gt. smod(jt+1)) goto 12221
      place=1
      go to 12230
12221 continue
      if(s .lt. smod(jt+n)) goto 12251
      place=n
      go to 12230
12251 continue
      low=0
      high=n+1
12261 if(low+1.ge.high) goto 12262
      place=(low+high)/2
      t=smod(jt+place)
      if(s.eq.t) goto 12230
      if(s .ge. t) goto 12281
      high=place
      goto 12291
12281 continue
      low=place
12291 continue
12271 continue
      goto 12261
12262 continue
      jfl=jf+low
      jfh=jf+high
      jtl=jt+low
      jth=jt+high
      t=smod(jfl)+(smod(jfh)-smod(jfl))*(s-smod(jtl))  /
     & (smod(jth)-smod(jtl))
      go to 12300
12230 continue
      t=smod(jf+place)
12300 continue
      do 12311 i=1,q
         y(inp,i)=y(inp,i)+smod(jb+i)*t
12311 continue
      ja=ja+p
      jb=jb+q
      jf=jf+n
      jt=jt+n
12191 continue
      do 12321 i=1,q
         y(inp,i)=ys*y(inp,i)+smod(i+5)
12321 continue
100   continue
      return
      end

      subroutine BDRsupsmu (n,x,y,w,iper,span,alpha,smo,sc,edf)
c
c------------------------------------------------------------------
c
c super smoother (Friedman, 1984).
c
c version 10/10/84
c
c coded  and copywrite (c) 1984 by:
c
c                        Jerome H. Friedman
c                     department of statistics
c                               and
c                stanford linear accelerator center
c                        stanford university
c
c all rights reserved.
c
c
c input:
c    n : number of observations (x,y - pairs).
c    x(n) : ordered abscissa values.
c    y(n) : corresponding ordinate (response) values.
c    w(n) : weight for each (x,y) observation.
c    iper : periodic variable flag.
c       iper=1 => x is ordered interval variable.
c       iper=2 => x is a periodic variable with values
c                 in the range (0.0,1.0) and period 1.0.
c    span : smoother span (fraction of observations in window).
c           span=0.0 => automatic (variable) span selection.
c    alpha : controls high frequency (small span) penality
c            used with automatic span selection (bass tone control).
c            (alpha.le.0.0 or alpha.gt.10.0 => no effect.)
c output:
c   smo(n) : smoothed ordinate (response) values.
c scratch:
c   sc(n,7) : internal working storage.
c
c note:
c    for small samples (n < 40) or if there are substantial serial
c    correlations between observations close in x - value, then
c    a prespecified fixed span smoother (span > 0) should be
c    used. reasonable span values are 0.2 to 0.4.
c
c------------------------------------------------------------------
c
      implicit double precision (a-h, o-z)
      dimension x(n),y(n),w(n),smo(n),sc(n,7)
      double precision df, gcvpen
      common /BDRspans/ spans(3) /BDRconsts/ big,sml,eps
      common /BDRspsmooth/ df, gcvpen, ismethod

      if (x(n).gt.x(1)) go to 30
      sy=0d0
      sw=sy
      do 10 j=1,n
         sy=sy+w(j)*y(j)
         sw=sw+w(j)
 10   continue
      a=0d0
      if (sw.gt.0d0) a=sy/sw
      do 20 j=1,n
         smo(j)=a
 20   continue
      return
 30   continue
C     change by BDR
      if (ismethod .ne. 0) then
        call BDRspline(n, x, y, w, smo, edf)
      else
      i=n/4
      j=3*i
      scale=x(j)-x(i)
 40   if (scale.gt.0d0) go to 50
      if (j.lt.n) j=j+1
      if (i.gt.1) i=i-1
      scale=x(j)-x(i)
      go to 40
 50   vsmlsq=(eps*scale)**2
      jper=iper
      if (iper.eq.2.and.(x(1).lt.0d0.or.x(n).gt.1d0)) jper=1
      if (jper.lt.1.or.jper.gt.2) jper=1
      if (span.le.0d0) go to 60
      call BDRsmooth (n,x,y,w,span,jper,vsmlsq,smo,sc)
      return
 60   do 70 i=1,3
      call BDRsmooth (n,x,y,w,spans(i),jper,vsmlsq,sc(1,2*i-1),sc(1,7))
      call BDRsmooth (n,x,sc(1,7),w,spans(2),-jper,vsmlsq,sc(1,2*i),h)
 70   continue
      do 90 j=1,n
      resmin=big
      do 80 i=1,3
      if (sc(j,2*i).ge.resmin) go to 80
      resmin=sc(j,2*i)
      sc(j,7)=spans(i)
 80   continue
      if (alpha.gt.0d0.and.alpha.le.10d0.and.resmin.lt.sc(j,6)
     & .and.resmin.gt.0d0) sc(j,7)=sc(j,7)+(spans(3)-sc(j,7))*
     & max(sml,resmin/sc(j,6))**(10.d0-alpha)
 90   continue
      call BDRsmooth (n,x,sc(1,7),w,spans(2),-jper,vsmlsq,sc(1,2),h)
      do 110 j=1,n
      if (sc(j,2).le.spans(1)) sc(j,2)=spans(1)
      if (sc(j,2).ge.spans(3)) sc(j,2)=spans(3)
      f=sc(j,2)-spans(2)
      if (f.ge.0d0) go to 100
      f=-f/(spans(2)-spans(1))
      sc(j,4)=(1d0-f)*sc(j,3)+f*sc(j,1)
      go to 110
 100  f=f/(spans(3)-spans(2))
      sc(j,4)=(1d0-f)*sc(j,3)+f*sc(j,5)
 110  continue
      call BDRsmooth (n,x,sc(1,4),w,spans(1),-jper,vsmlsq,smo,h)
      edf = 0
      endif
      return
      end

      subroutine BDRsmooth (n,x,y,w,span,iper,vsmlsq,smo,acvr)
      implicit double precision (a-h, o-z)
      dimension x(n),y(n),w(n),smo(n),acvr(n)
      integer in,out
      double precision wt,fbo,fbw,xm,ym,tmp,var,cvar,a,h,sy
      xm=0d0
      ym=xm
      var=ym
      cvar=var
      fbw=cvar
      jper=iabs(iper)
      ibw=0.5*span*n+0.5
      if (ibw.lt.2) ibw=2
      it=2*ibw+1
      do 20 i=1,it
      j=i
      if (jper.eq.2) j=i-ibw-1
      xti=x(j)
      if (j.ge.1) go to 10
      j=n+j
      xti=x(j)-1d0
 10   wt=w(j)
      fbo=fbw
      fbw=fbw+wt
      if (fbw.gt.0d0) xm=(fbo*xm+wt*xti)/fbw
      if (fbw.gt.0d0) ym=(fbo*ym+wt*y(j))/fbw
      tmp=0d0
      if (fbo.gt.0d0) tmp=fbw*wt*(xti-xm)/fbo
      var=var+tmp*(xti-xm)
      cvar=cvar+tmp*(y(j)-ym)
 20   continue
      do 80 j=1,n
      out=j-ibw-1
      in=j+ibw
      if ((jper.ne.2).and.(out.lt.1.or.in.gt.n)) go to 60
      if (out.ge.1) go to 30
      out=n+out
      xto=x(out)-1d0
      xti=x(in)
      go to 50
 30   if (in.le.n) go to 40
      in=in-n
      xti=x(in)+1d0
      xto=x(out)
      go to 50
 40   xto=x(out)
      xti=x(in)
 50   wt=w(out)
      fbo=fbw
      fbw=fbw-wt
      tmp=0d0
      if (fbw.gt.0d0) tmp=fbo*wt*(xto-xm)/fbw
      var=var-tmp*(xto-xm)
      cvar=cvar-tmp*(y(out)-ym)
      if (fbw.gt.0d0) xm=(fbo*xm-wt*xto)/fbw
      if (fbw.gt.0d0) ym=(fbo*ym-wt*y(out))/fbw
      wt=w(in)
      fbo=fbw
      fbw=fbw+wt
      if (fbw.gt.0d0) xm=(fbo*xm+wt*xti)/fbw
      if (fbw.gt.0d0) ym=(fbo*ym+wt*y(in))/fbw
      tmp=0d0
      if (fbo.gt.0d0) tmp=fbw*wt*(xti-xm)/fbo
      var=var+tmp*(xti-xm)
      cvar=cvar+tmp*(y(in)-ym)
 60   a=0d0
      if (var.gt.vsmlsq) a=cvar/var
      smo(j)=a*(x(j)-xm)+ym
      if (iper.le.0) go to 80
      h=0d0
      if (fbw.gt.0d0) h=1d0/fbw
      if (var.gt.vsmlsq) h=h+(x(j)-xm)**2/var
      acvr(j)=0d0
      a=1d0-w(j)*h
      if (a.le.0d0) go to 70
      acvr(j)=abs(y(j)-smo(j))/a
      go to 80
 70   if (j.le.1) go to 80
      acvr(j)=acvr(j-1)
 80   continue
      j=1
 90   j0=j
      sy=smo(j)*w(j)
      fbw=w(j)
      if (j.ge.n) go to 110
 100  if (x(j+1).gt.x(j)) go to 110
      j=j+1
      sy=sy+w(j)*smo(j)
      fbw=fbw+w(j)
      if (j.lt.n) go to 100
 110  if (j.le.j0) go to 130
      a=0d0
      if (fbw.gt.0d0) a=sy/fbw
      do 120 i=j0,j
         smo(i)=a
 120  continue
 130  j=j+1
      if (j.le.n) go to 90
      return
      end

      block data BDRbksupsmu
      implicit double precision (a-h, o-z)
      common /BDRspans/ spans(3) /BDRconsts/ big,sml,eps
c
c---------------------------------------------------------------
c
c this sets the compile time (default) values for various
c internal parameters :
c
c spans : span values for the three running linear smoothers.
c spans(1) : tweeter span.
c spans(2) : midrange span.
c spans(3) : woofer span.
c (these span values should be changed only with care.)
c big : a large representable floating point number.
c sml : a small number. should be set so that (sml)**(10.0) does
c       not cause floating point underflow.
c eps : used to numerically stabilize slope calculations for
c       running linear fits.
c
c these parameter values can be changed by declaring the
c relevant labeled common in the main program and resetting
c them with executable statements.
c
c-----------------------------------------------------------------
c
      data spans,big,sml,eps /0.05d0,0.2d0,0.5d0,1.d20,1.d-7,1.d-3/
      end


      subroutine BDRspline (n, x, y, w, smo, edf)
c
c------------------------------------------------------------------
c
c input:
c    n : number of observations.
c    x(n) : ordered abscissa values.
c    y(n) : corresponding ordinate (response) values.
c    w(n) : weight for each (x,y) observation.
c output:
c   smo(n) : smoothed ordinate (response) values.
c   edf : equivalent degrees of freedom
c
c------------------------------------------------------------------
c
      implicit double precision (a-h, o-z)
      dimension x(n),y(n),w(n),smo(n)
      double precision knot(29), coef(25), work((17+25)*25)
      double precision df, df1, lambda, gcvpen, lev(2500), s
      double precision dx(2500), dy(2500), dw(2500), dsmo(2500)
      integer par(2)
      double precision param(3), crit
      common /BDRspsmooth/ df, gcvpen, ismethod
      do 10 i = 1,n
        dx(i) = (x(i)-x(1))/(x(n)-x(1))
        dy(i) = y(i)
 10     dw(i) = w(i)
      nk = min(n,15)
      knot(1) = dx(1)
      knot(2) = dx(1)
      knot(3) = dx(1)
      knot(4) = dx(1)
      knot(nk+1) = dx(n)
      knot(nk+2) = dx(n)
      knot(nk+3) = dx(n)
      knot(nk+4) = dx(n)
      do 40 i = 5, nk
        p = (n-1)*real(i-4)/real(nk-3)
        ip = int(p)
        p = p-ip
        knot(i) = (1-p)*dx(ip+1) + p*dx(ip+2)
 40     continue
c      call dblepr('knots', 5, knot, nk+4)
C	par = (icrit, ispar)
      if (iabs(ismethod) .eq. 1) then
        par(1) = 3
        df1 = df
      else
         par(1) = 1
         df1 = 0d0
      endif
      par(2) = 0
      param(1) = 0d0
      param(2) = 1.5d0
      param(3) = 1d-2
      isetup = 0
      ier = 1
      call VRqsbart(gcvpen,df1,dx,dy,dw,n,knot,nk,coef,dsmo,lev,crit,
     & par,lambda,param,isetup, work,4,1,ier)
      if(ier .gt. 0) call intpr('Trouble in ppr',14, ier, 1)
      do 50 i = 1,n
 50     smo(i) = dsmo(i)
c      call dblepr('smoothed',8, dsmo, n)
      s = 0
      do 60 i = 1, n
 60      s = s + lev(i)
      edf = s
      if(ismethod.lt.0) then
        call dblepr('lambda', 6, lambda, 1)
        call dblepr('df', 2, s, 1)
      endif
      return
      end


***********************************************************************


      subroutine BDRsort (v,a,ii,jj)
      implicit double precision (a-h, o-z)
c
c     puts into a the permutation vector which sorts v into
c     increasing order.  only elements from ii to jj are considered.
c     arrays iu(k) and il(k) permit sorting up to 2**(k+1)-1 elements
c
c     this is a modification of CACM algorithm #347 by R. C. Singleton,
c     which is a modified Hoare quicksort.
c
      dimension a(jj),v(*),iu(20),il(20)
      integer t,tt
      double precision v
      m=1
      i=ii
      j=jj
 10   if (i.ge.j) go to 80
 20   k=i
      ij=(j+i)/2
      t=a(ij)
      vt=v(ij)
      if (v(i).le.vt) go to 30
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
 30   l=j
      if (v(j).ge.vt) go to 50
      a(ij)=a(j)
      a(j)=t
      t=a(ij)
      v(ij)=v(j)
      v(j)=vt
      vt=v(ij)
      if (v(i).le.vt) go to 50
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
      go to 50
 40   a(l)=a(k)
      a(k)=tt
      v(l)=v(k)
      v(k)=vtt
 50   l=l-1
      if (v(l).gt.vt) go to 50
      tt=a(l)
      vtt=v(l)
 60   k=k+1
      if (v(k).lt.vt) go to 60
      if (k.le.l) go to 40
      if (l-i.le.j-k) go to 70
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 90
 70   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 90
 80   m=m-1
      if (m.eq.0) return
      i=il(m)
      j=iu(m)
 90   if (j-i.gt.10) go to 20
      if (i.eq.ii) go to 10
      i=i-1
 100  i=i+1
      if (i.eq.j) go to 80
      t=a(i+1)
      vt=v(i+1)
      if (v(i).le.vt) go to 100
      k=i
 110  a(k+1)=a(k)
      v(k+1)=v(k)
      k=k-1
      if (vt.lt.v(k)) go to 110
      a(k+1)=t
      v(k+1)=vt
      go to 100
      end
C An interface to VRsbart() --- less arguments BUT unspecified scrtch() dimension
C
C unused !
C
      subroutine VRqsbart(penalt,dofoff,xs,ys,ws,n,knot,nk,
     &     coef,sz,lev,
     &     crit,iparms,spar,parms,
     &     isetup, scrtch, ld4,ldnk,ier)
c
      implicit none

      integer n,nk,isetup, iparms(2), ld4,ldnk,ier
      double precision penalt,dofoff, xs(n),ys(n),ws(n),
     &     knot(nk+4), coef(nk),sz(n),lev(n), 
     &     crit,spar,parms(3),
     &     scrtch(*)
C          ^^^^^^^^ dimension (9+2*ld4+nk)*nk

      call VRsbart(penalt,dofoff,xs,ys,ws,n,knot,nk,
     &     coef,sz,lev, crit,
     &     iparms(1),spar,iparms(2),parms(1),parms(2),parms(3),
     &     isetup,
     &     scrtch(     1),scrtch(  nk+1),scrtch(2*nk+1),scrtch(3*nk+1),
     &     scrtch(4*nk+1),scrtch(5*nk+1),scrtch(6*nk+1),scrtch(7*nk+1),
     &     scrtch(8*nk+1),scrtch(9*nk+1),
     &     scrtch(9*nk+  ld4*nk+1),
     &     scrtch(9*nk+2*ld4*nk+1), ld4,ldnk,ier)

      return
      end

C  VRsbart() : The cubic spline smoother
C  -------
C Calls	 sgram	(sg0,sg1,sg2,sg3,knot,nk)
C	 VRstxwx	(xs,ys,ws,n,knot,nk,xwy,hs0,hs1,hs2,hs3)
C	 VRsslvrg (penalt,dofoff,xs,ys,ws,n,knot,nk,  coef,sz,lev,crit,icrit,
C		 spar,ratio, xwy, hs0,hs1,hs2,hs3, sg0,sg1,sg2,sg3,
C		 abd,p1ip,p2ip,ld4,ldnk,ier)
C
C
      subroutine VRsbart(penalt,dofoff,xs,ys,ws,n,knot,nk,
     &	   coef,sz,lev, crit,icrit,
     &	   spar,ispar,lspar,uspar,
     &	   tol,isetup, xwy,
     &	   hs0,hs1,hs2,hs3, sg0,sg1,sg2,sg3,
     &	   abd,p1ip,p2ip,ld4,ldnk,ier)

      implicit none
c     -------------

C A Cubic B-spline Smoothing routine.
C
C  The algorithm minimises:
C
C      (1/n) * sum ws(i)**2 * (ys(i)-sz(i))**2 + lambda* int ( sz"(xs) )**2 dxs
C
C  lambda is a function of the spar which is assumed to be between 0 and 1
C
C INPUT
C -----
C penalt	A penalty > 1 to be used in the gcv criterion
C   n		number of data points
C  ys(n)	vector of length n containing the observations
C  ws(n)	vector containing the weights given to each data point
C  xs(n)	vector containing the ordinates of the observations
C  nk		number of b-spline coefficients to be estimated
C		nk <= n+2
C  knot(nk+4)	vector of knot points defining the cubic b-spline basis.
C		To obtain full cubic smoothing splines one might
C		have (provided the xs-values are strictly increasing)
C  spar		penalised likelihood smoothing parameter
C  ispar	indicator saying if spar is supplied or to be estimated
C  lspar, uspar lower and upper values for spar;  0.,1. are good values
C  tol		used in Golden Search routine
C  isetup	setup indicator
C  icrit	indicator saying which cross validation score
C		is to be computed
C  ld4		the leading dimension of abd (ie ld4=4)
C  ldnk		the leading dimension of p2ip (not referenced)
		
C OUTPUT	
C ------	
C   coef(nk)	vector of spline coefficients
C   sz(n)	vector of smoothed z-values
C   lev(n)	vector of leverages
C   crit	either ordinary of generalized CV score
C   ier		error indicator
C		ier = 0 ___  everything fine
C		ier = 1 ___  spar too small or too big
C				 problem in cholesky decomposition

C Working arrays/matrix
C   xwy			X'Wy
C   hs0,hs1,hs2,hs3	the diagonals of the X'WX matrix
C   sg0,sg1,sg2,sg3	the diagonals of the Gram matrix
C   abd(ld4,nk)		[ X'WX + lambda*SIGMA ] in diagonal form
C   p1ip(ld4,nk)	inner products between columns of L inverse
C   p2ip(ldnk,nk)	all inner products between columns of L inverse
C			where  L'L = [X'WX + lambda*SIGMA]  NOT REFERENCED
      
      integer n, nk,isetup,icrit,ispar,ld4,ldnk,ier
      double precision penalt,dofoff,xs(n),ys(n),ws(n),
     &     knot(nk+4), coef(nk),sz(n),lev(n), crit,spar,lspar,uspar,tol,
     &     xwy(nk),hs0(nk),hs1(nk),hs2(nk),hs3(nk), 
     &     sg0(nk),sg1(nk),sg2(nk),sg3(nk),
     &     abd(ld4,nk), p1ip(ld4,nk),p2ip(ldnk,nk)
C Local variables
      double precision t1,t2,ratio, a,b,c,d,e,eps,xm,p,
     &     q,r,tol1,tol2,u,v,w, fu,fv,fw,fx,x, ax,bx
      integer i


C  Compute SIGMA, X' W**2 X, X' W**2 z, trace ratio, s0, s1.

C     		SIGMA     -> sg0,sg1,sg2,sg3
C     		X' W**2 X -> hs0,hs1,hs2,hs3
C     		X' W**2 Z -> xwy

C trevor fixed this 4/19/88
C Note: sbart uses the square of the weights
C the following rectifies that
      if(n .ge. 1) then
         do 5 i=1,n
            if(ws(i).gt.0)then
               ws(i)=sqrt(ws(i)) 
            endif
 5       continue
      endif

      if(isetup.eq.0)then
         call VRsgram(sg0,sg1,sg2,sg3,knot,nk)
         call VRstxwx(xs,ys,ws,n,knot,nk,xwy,hs0,hs1,hs2,hs3)
         t1=0. 
         t2=0.
         do 7 i=3,nk-3 
            t1 = t1 + hs0(i) 
            t2 = t2 + sg0(i) 
 7       continue
         ratio = t1/t2
         isetup = 1 
C     Compute estimate
      endif
      
      if(ispar.eq.1) then
C     Value of spar supplied
         call VRsslvrg(penalt,dofoff,xs,ys,ws,n,knot,nk,
     &        coef,sz,lev,crit,icrit,
     &        spar,ratio, xwy,
     &        hs0,hs1,hs2,hs3, sg0,sg1,sg2,sg3,
     &        abd,p1ip,p2ip,ld4,ldnk,ier)

C     check 2
C print 2999;2999 format(" got through check 2")

      else
c     ---- spar not supplied --> compute it ! -------------------------

C     Use Forsythe Malcom and Moler routine to minimise criterion
         ax=lspar 
C     f denotes the value of the criterion
         bx=uspar
C     
C     an approximation	x  to the point where	f  attains a minimum  on
C     the interval  (ax,bx)  is determined.
C     
C
C  input..
C
C  ax	 left endpoint of initial interval
C  bx	 right endpoint of initial interval
C  f	 function subprogram which evaluates  f(x)  for any  x
C	 in the interval  (ax,bx)
C  tol	 desired length of the interval of uncertainty of the final
C	 result ( .ge. 0.0)
C
C
C  output..
C
C  fmin	 abcissa approximating the point where	f  attains a minimum
C
C
C      the method used is a combination of  golden  section  search  and
C  successive parabolic interpolation.	convergence is never much slower
C  than	 that  for  a  fibonacci search.  if  f	 has a continuous second
C  derivative which is positive at the minimum (which is not  at  ax  or
C  bx),	 then  convergence  is	superlinear, and usually of the order of
C  about  1.324....
C      the function  f	is never evaluated at two points closer together
C  than	 eps*abs(fmin) + (tol/3), where eps is	approximately the square
C  root	 of  the  relative  machine  precision.	  if   f   is a unimodal
C  function and the computed values of	 f   are  always  unimodal  when
C  separated by at least  eps*abs(x) + (tol/3), then  fmin  approximates
C  the abcissa of the global minimum of	 f  on the interval  ax,bx  with
C  an error less than  3*eps*abs(fmin) + tol.  if   f	is not unimodal,
C  then fmin may approximate a local, but perhaps non-global, minimum to
C  the same accuracy.
C      this function subprogram is a slightly modified	version	 of  the
C  algol  60 procedure	localmin  given in richard brent, algorithms for
C  minimization without derivatives, prentice - hall, inc. (1973).
C
C
C      DOUBLE precision	 a,b,c,d,e,eps,xm,p,q,r,tol1,tol2,u,v,w
C      DOUBLE precision	 fu,fv,fw,fx,x
C
C  c is the squared inverse of the golden ratio
C
      c = 0.5*(3. - sqrt(5d0))
C
C  eps is approximately the square root of the relative machine
C  precision.
C
c-       eps = 1e0
c- 10    eps = eps/2e0
c-       tol1 = 1e0 + eps
c-       if (tol1 .gt. 1e0) go to 10
c-       eps = sqrt(eps)
      eps=.000244
C
C  initialization
C
      a = ax
      b = bx
      v = a + c*(b - a)
      w = v
      x = v
      e = 0.0
      spar = x
      call VRsslvrg(penalt,dofoff,xs,ys,ws,n,knot,nk,
     &	   coef,sz,lev,crit,icrit,
     &	   spar,ratio, xwy,
     &	   hs0,hs1,hs2,hs3, sg0,sg1,sg2,sg3,
     &	   abd,p1ip,p2ip,ld4,ldnk,ier)
      fx = crit
      fv = fx
      fw = fx
C
C  main loop starts here
C
20    xm = 0.5*(a + b)
      tol1 = eps*abs(x) + tol/3d0
      tol2 = 2d0*tol1
C
C  check stopping criterion
C
      if(abs(x - xm) .le. (tol2 - 0.5*(b - a)))	     go to 990
C
C is golden-section necessary
C
      if(abs(e) .le. tol1)	go to 40
C
C  fit parabola
C
      r = (x - w)*(fx - fv)
      q = (x - v)*(fx - fw)
      p = (x - v)*q - (x - w)*r
      q = 2.00*(q - r)
      if (q .gt. 0d0) p = -p
      q = abs(q)
      r = e
      e = d
C
C  is parabola acceptable?  Otherwise do golden-section
C
      if (abs(p) .ge. abs(0.5*q*r)) go to 40
      if (q .le. 1d-10) go to 40
      if (p .le. q*(a - x)) go to 40
      if (p .ge. q*(b - x)) go to 40
C
C  a parabolic interpolation step
C
      d = p/q
      u = x + d
C
C  f must not be evaluated too close to ax or bx
C
      if ((u - a) .lt. tol2) d = sign(tol1, xm - x)
      if ((b - u) .lt. tol2) d = sign(tol1, xm - x)
      go to 50
C     --------      
C
C  a golden-section step
C
   40 if (x .ge. xm) e = a - x
      if (x .lt. xm) e = b - x
      d = c*e
C
C  f must not be evaluated too close to x
C     
 50   if (abs(d) .ge. tol1) u = x + d
      if (abs(d) .lt. tol1) u = x + sign(tol1, d)
      
      spar = u
      call VRsslvrg(penalt,dofoff,xs,ys,ws,n,knot,nk,
     &	   coef,sz,lev,crit,icrit,
     &	   spar,ratio, xwy,
     &	   hs0,hs1,hs2,hs3, sg0,sg1,sg2,sg3,
     &	   abd,p1ip,p2ip,ld4,ldnk,ier)
      fu = crit
C
C  update  a, b, v, w, and x
C
c  checkout NA
      if (.not. (fu .le. fx) .and. (.not. (fu .ge. fx))) then
         ier = 2
         return
      endif
      if (fu .gt. fx) go to 60
      if (u .ge. x) a = x
      if (u .lt. x) b = x
      v = w
      fv = fw
      w = x
      fw = fx
      x = u
      fx = fu
      go to 20
60    if(u .lt. x) then
	 a = u
      else
	 b = u
      endif
      if (fu .le. fw) go to 70
      if (w .eq. x) go to 70
      if (fu .le. fv) go to 80
      if (v .eq. x) go to 80
      if (v .eq. w) go to 80
      go to 20
70    v = w
      fv = fw
      w = u
      fw = fu
      go to 20
80    v = u
      fv = fu
      go to 20
C
C  end of main loop
C
 990  continue 
      spar = x 
      crit = fx
      endif
      return
      end

C Output from Public domain Ratfor, version 1.0

C PURPOSE
C 	Calculation of the cubic B-spline smoothness prior
C 	for "usual" interior knot setup.
C	Uses BSPVD and INTRV in the CMLIB
C	sgm[0-3](nb)    Symmetric matrix
C                       whose (i,j)'th element contains the integral of
C                       B''(i,.) B''(j,.) , i=1,2 ... nb and j=i,...nb.
C                       Only the upper four diagonals are computed.

      subroutine VRsgram(sg0,sg1,sg2,sg3,tb,nb)

      implicit none
C indices
      integer nb
      DOUBLE precision sg0(nb),sg1(nb),sg2(nb),sg3(nb), tb(nb+4)
c     -------------
      integer ileft,ilo,mflag, i,ii,jj, lentb
      DOUBLE precision vnikx(4,3),work(16),yw1(4),yw2(4), wpt

      lentb=nb+4
C Initialise the sigma vectors
      do 1 i=1,nb
         sg0(i)=0.
         sg1(i)=0.
         sg2(i)=0.
         sg3(i)=0.
 1    continue

      ilo = 1
      do 2 i=1,nb
C     Calculate a linear approximation to the
C     second derivative of the non-zero B-splines
C     over the interval [tb(i),tb(i+1)].
C     call intrv(tb(1),(nb+1),tb(i),ilo,ileft,mflag)
         call VRint(tb(1),(nb+1),tb(i),ileft,mflag)
C     Left end second derivatives
C     call bspvd (tb,4,3,tb(i),ileft,4,vnikx,work)
         call VRbsplvd (tb,lentb,4,tb(i),ileft,work,vnikx,3)
C     Put values into yw1
         do 4 ii=1,4
            yw1(ii) = vnikx(ii,3)
 4       continue

C     Right end second derivatives
C     call bspvd (tb,4,3,tb(i+1),ileft,4,vnikx,work)
         call VRbsplvd (tb,lentb,4,tb(i+1),ileft,work,vnikx,3)

C     Slope*(length of interval) in Linear Approximation to B''
         do    6 ii=1,4
            yw2(ii) = vnikx(ii,3) - yw1(ii)
 6       continue

         wpt = tb(i+1) - tb(i)
C     Calculate Contributions to the simga vectors
         if(ileft.ge.4) then
            do 10 ii=1,4
               jj=ii
               sg0(ileft-4+ii) = sg0(ileft-4+ii) +
     &              wpt*(yw1(ii)*yw1(jj)+
     &                   (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                  + yw2(ii)*yw2(jj)*.3330)
               jj=ii+1
               if(jj.le.4)then
                  sg1(ileft+ii-4) = sg1(ileft+ii-4) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               endif
               jj=ii+2
               if(jj.le.4)then
                  sg2(ileft+ii-4) = sg2(ileft+ii-4) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               endif
               jj=ii+3
               if(jj.le.4)then
                  sg3(ileft+ii-4) = sg3(ileft+ii-4) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               endif
 10         continue

         else if(ileft.eq.3)then
            do    20 ii=1,3
               jj=ii
               sg0(ileft-3+ii) = sg0(ileft-3+ii) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               jj=ii+1
               if(jj.le.3)then
                  sg1(ileft+ii-3) = sg1(ileft+ii-3) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               endif
               jj=ii+2
               if(jj.le.3)then
                  sg2(ileft+ii-3) = sg2(ileft+ii-3) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               endif
 20         continue

         else if(ileft.eq.2)then
            do    28 ii=1,2
               jj=ii
               sg0(ileft-2+ii) = sg0(ileft-2+ii) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               jj=ii+1
               if(jj.le.2)then
                  sg1(ileft+ii-2) = sg1(ileft+ii-2) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
               endif
 28         continue

         else if(ileft.eq.1)then
            do 34 ii=1,1
               jj=ii
               sg0(ileft-1+ii) = sg0(ileft-1+ii) +
     &                 wpt* (yw1(ii)*yw1(jj) +
     *                       (yw2(ii)*yw1(jj) + yw2(jj)*yw1(ii))*.50
     &                       +yw2(ii)*yw2(jj)*.3330 )
 34         continue

         endif
 2    continue

      return
      end

C Output from Public domain Ratfor, version 1.0
      subroutine VRsslvrg(penalt,dofoff, x,y,w,n, knot,nk, coef,sz,lev,
     *     crit,icrit, spar,ratio, xwy, hs0,hs1,hs2,hs3,
     *     sg0,sg1,sg2,sg3, abd,p1ip,p2ip,ld4,ldnk,info)

      implicit none
c     -------------
      integer n,nk,icrit,ld4,ldnk,info
      DOUBLE precision penalt,dofoff,x(n),y(n),w(n),
     &     knot(nk+4), coef(nk),sz(n),lev(n), crit, spar,ratio,
     *     xwy(nk), hs0(nk),hs1(nk),hs2(nk),hs3(nk),
     *     sg0(nk),sg1(nk),sg2(nk),sg3(nk), abd(ld4,nk),
     &     p1ip(ld4,nk),p2ip(ldnk,nk)

      EXTERNAL VRbval
      double precision VRbval
C local variables
      double precision vnikx(4,1),work(16)
      integer i,icoef,ileft,ilo,j,mflag, lenkno
      double precision lambda,b0,b1,b2,b3,eps, xv,rss,df, sumw

      lenkno=nk+4
      ilo = 1
      eps = .1d-10
C Purpose : Solves the smoothing problem and computes the
C           criterion function (OCV or GCV).
C The coeficients of estimated smooth
      lambda = ratio*16.**(-2. + spar*(6.))
      do 1 i=1,nk
         coef(i) = xwy(i)
 1    continue
      do   2 i=1,nk
         abd(4,i) = hs0(i)+lambda*sg0(i)
 2    continue

      do   4 i=1,(nk-1)
         abd(3,i+1) = hs1(i)+lambda*sg1(i)
 4    continue

      do   6 i=1,(nk-2)
         abd(2,i+2) = hs2(i)+lambda*sg2(i)
 6    continue

      do   8 i=1,(nk-3)
         abd(1,i+3) = hs3(i)+lambda*sg3(i)
 8    continue

      call dpbfa(abd,ld4,nk,3,info)
      if(info.ne.0)then
         return
      endif
      call dpbsl(abd,ld4,nk,3,coef)
C     Value of smooth at the data points
      icoef = 1
      do 12 i=1,n
         xv = x(i)
C        sz(i) = bvalu (knot,       coef, nk,4,0,xv,icoef,work(1)) 
         sz(i) = VRbval(knot,lenkno,coef, nk,4,xv,0)
C     Compute the criterion function if requested
 12   continue

      if(icrit.eq.0)then
         return
      else
C     Ordinary or Generalized CV
C     Get Leverages First
         call VRsinerp(abd,ld4,nk,p1ip,p2ip,ldnk,0)
         do    16 i=1,n
            xv = x(i)
C     call intrv(knot(1),(nk+1),xv,ilo,ileft,mflag)
            call VRint(knot(1),(nk+1),xv,ileft,mflag)
            if(mflag.eq.-1)then
               ileft = 4
               xv = knot(4)+eps
            endif
            if(mflag.eq.1)then
               ileft = nk
               xv = knot(nk+1)-eps
            endif
            j=ileft-3
C     call bspvd(knot,4,1,xv,ileft,4,vnikx,work)
            call VRbsplvd(knot,lenkno,4,xv,ileft,work,vnikx,1)
            b0=vnikx(1,1)
            b1=vnikx(2,1)
            b2=vnikx(3,1)
            b3=vnikx(4,1)
            lev(i) = (
     &              p1ip(4,j)*b0**2   + 2.*p1ip(3,j)*b0*b1 +
     *           2.*p1ip(2,j)*b0*b2   + 2.*p1ip(1,j)*b0*b3 +
     *              p1ip(4,j+1)*b1**2 + 2.*p1ip(3,j+1)*b1*b2 +
     *           2.*p1ip(2,j+1)*b1*b3 +    p1ip(4,j+2)*b2**2 +
     &           2.*p1ip(3,j+2)*b2*b3 +    p1ip(4,j+3)*b3**2
     &           )*w(i)**2
C     Evaluate Criterion
 16      continue

         if(icrit.eq.1)then
C     Generalized CV
            rss= 0d0
            df = 0d0
            sumw=0d0
            do    24 i=1,n
               rss = rss + ((y(i)-sz(i))*w(i))**2
 24         continue
            do    26 i=1,n
               df = df + lev(i)
C     do i=1,n { sumw  = sumw  + w(i)}
 26         continue

            crit = (rss/n)/((1d0-(dofoff+penalt*df)/n)**2)
C     crit = (rss/n)/((1d0-(dofoff+penalt*df)/sumw)**2)
         else
            if(icrit.eq.2)then
C     Ordinary CV
               crit = 0d0
               do    30 i=1,n
                  crit = crit + (((y(i)-sz(i))*w(i))/(1-lev(i)))**2
 30            continue
               crit=crit/n
            else
C     df matching
               crit=0d0
               do    32 i=1,n
                  crit=crit+lev(i)
 32            continue
               crit=3+(dofoff-crit)**2
            endif
         endif
         return
      endif
      end

C Output from Public domain Ratfor, version 1.0
      subroutine VRstxwx(x,z,w,k,xknot,n,y,hs0,hs1,hs2,hs3)

      implicit none
      integer k,n
      DOUBLE precision x(k),z(k),w(k), xknot(n+4),y(n),
     &	   hs0(n),hs1(n),hs2(n),hs3(n)
C local
      DOUBLE precision eps,vnikx(4,1),work(16)
      integer lenxk,ilo, i,j, ileft,mflag

      lenxk=n+4
C     Initialise the output vectors
      do 1 i=1,n
	 y(i)=0d0
	 hs0(i)=0d0
	 hs1(i)=0d0
	 hs2(i)=0d0
	 hs3(i)=0d0
 1    continue

C     Compute X'WX -> hs0,hs1,hs2,hs3  and X'WZ -> y
      ilo=1
      eps= .1d-9

      do 100 i=1,k
C	 call intrv (xknot(1),(n+1),x(i),ilo,ileft,mflag)
	 call VRint(xknot(1),(n+1),x(i),ileft,mflag)
C        if(mflag==-1) {write(6,'("Error in hess ",i2)')mflag;stop}
C        if(mflag==-1) {return}
	 if(mflag.eq. 1)then
	    if(x(i).le.(xknot(ileft)+eps))then
	       ileft=ileft-1
	    else
	       return
	    endif
C        else{write(6,'("Error in hess ",i2)')mflag;stop}}
	 endif
C	 call bspvd (xknot,4,1,x(i),ileft,4,vnikx,work)
	 call VRbsplvd (xknot,lenxk,4,x(i),ileft,work,vnikx,1)

C     check 2
C     print 2999;2999 format(" got through check2 VRstxwx ")
	 j= ileft-4+1
	 y(j) = y(j)+w(i)**2*z(i)*vnikx(1,1)
	 hs0(j)=hs0(j)+w(i)**2*vnikx(1,1)**2
	 hs1(j)=hs1(j)+w(i)**2*vnikx(1,1)*vnikx(2,1)
	 hs2(j)=hs2(j)+w(i)**2*vnikx(1,1)*vnikx(3,1)
	 hs3(j)=hs3(j)+w(i)**2*vnikx(1,1)*vnikx(4,1)
	 j= ileft-4+2
	 y(j) = y(j)+w(i)**2*z(i)*vnikx(2,1)
	 hs0(j)=hs0(j)+w(i)**2*vnikx(2,1)**2
	 hs1(j)=hs1(j)+w(i)**2*vnikx(2,1)*vnikx(3,1)
	 hs2(j)=hs2(j)+w(i)**2*vnikx(2,1)*vnikx(4,1)
	 j= ileft-4+3
	 y(j) = y(j)+w(i)**2*z(i)*vnikx(3,1)
	 hs0(j)=hs0(j)+w(i)**2*vnikx(3,1)**2
	 hs1(j)=hs1(j)+w(i)**2*vnikx(3,1)*vnikx(4,1)
	 j= ileft-4+4
	 y(j) = y(j)+w(i)**2*z(i)*vnikx(4,1)
	 hs0(j)=hs0(j)+w(i)**2*vnikx(4,1)**2
 100  continue

      return
      end
      subroutine VRbsplvd ( t, lent, k, x, left, a, dbiatx, nderiv )
c     --------   ------
      implicit none

C calculates value and deriv.s of all b-splines which do not vanish at x
C calls VRbsplvb
c
c******  i n p u t  ******
c  t     the knot array, of length left+k (at least)
c  k     the order of the b-splines to be evaluated
c  x     the point at which these values are sought
c  left  an integer indicating the left endpoint of the interval of
c        interest. the  k  b-splines whose support contains the interval
c               (t(left), t(left+1))
c        are to be considered.
c  a s s u m p t i o n  - - -  it is assumed that
c               t(left) .lt. t(left+1)
c        division by zero will result otherwise (in  b s p l v b ).
c        also, the output is as advertised only if
c               t(left) .le. x .le. t(left+1) .
c  nderiv   an integer indicating that values of b-splines and their
c        derivatives up to but not including the  nderiv-th  are asked
c        for. ( nderiv  is replaced internally by the integer in (1,k)
c        closest to it.)
c
c******  w o r k   a r e a  ******
c  a     an array of order (k,k), to contain b-coeff.s of the derivat-
c        ives of a certain order of the  k  b-splines of interest.
c
c******  o u t p u t  ******
c  dbiatx   an array of order (k,nderiv). its entry  (i,m)  contains
c        value of  (m-1)st  derivative of  (left-k+i)-th  b-spline of
c        order  k  for knot sequence  t , i=m,...,k; m=1,...,nderiv.
c
c******  m e t h o d  ******
c  values at  x  of all the relevant b-splines of order k,k-1,...,
c  k+1-nderiv  are generated via  VRbsplvb  and stored temporarily
c  in  dbiatx .  then, the b-coeffs of the required derivatives of the
c  b-splines of interest are generated by differencing, each from the
c  preceding one of lower order, and combined with the values of b-
c  splines of corresponding order in  dbiatx  to produce the desired
c  values.

C Args
      integer lent,k,left,nderiv
      double precision t(lent),x, dbiatx(k,nderiv), a(k,k)
C Locals
      double precision factor,fkp1mm,sum
      integer i,ideriv,il,j,jlow,jp1mid, kp1,kp1mm,ldummy,m,mhigh

      mhigh = max0(min0(nderiv,k),1)
c     mhigh is usually equal to nderiv.
      kp1 = k+1
      call VRbsplvb(t,lent,kp1-mhigh,1,x,left,dbiatx)
      if (mhigh .eq. 1)                 go to 99
c     the first column of  dbiatx  always contains the b-spline values
c     for the current order. these are stored in column k+1-current
c     order  before  VRbsplvb  is called to put values for the next
c     higher order on top of it.
      ideriv = mhigh
      do 15 m=2,mhigh
         jp1mid = 1
         do 11 j=ideriv,k
            dbiatx(j,ideriv) = dbiatx(jp1mid,1)
   11       jp1mid = jp1mid + 1
         ideriv = ideriv - 1
         call VRbsplvb(t,lent,kp1-ideriv,2,x,left,dbiatx)
   15    continue
c
c     at this point,  b(left-k+i, k+1-j)(x) is in  dbiatx(i,j) for
c     i=j,...,k and j=1,...,mhigh ('=' nderiv). in particular, the
c     first column of  dbiatx  is already in final form. to obtain cor-
c     responding derivatives of b-splines in subsequent columns, gene-
c     rate their b-repr. by differencing, then evaluate at  x.
c
      jlow = 1
      do 20 i=1,k
         do 19 j=jlow,k
   19       a(j,i) = 0e0
         jlow = i
   20    a(i,i) = 1e0
c     at this point, a(.,j) contains the b-coeffs for the j-th of the
c     k  b-splines of interest here.
c
      do 40 m=2,mhigh
         kp1mm = kp1 - m
         fkp1mm = dble(kp1mm)
         il = left
         i = k
c
c        for j=1,...,k, construct b-coeffs of  (m-1)st  derivative of
c        b-splines from those for preceding derivative by differencing
c        and store again in  a(.,j) . the fact that  a(i,j) = 0  for
c        i .lt. j  is used.sed.
         do 25 ldummy=1,kp1mm
            factor = fkp1mm/(t(il+kp1mm) - t(il))
c           the assumption that t(left).lt.t(left+1) makes denominator
c           in  factor  nonzero.
            do 24 j=1,i
   24          a(i,j) = (a(i,j) - a(i-1,j))*factor
            il = il - 1
   25       i = i - 1
c
c        for i=1,...,k, combine b-coeffs a(.,i) with b-spline values
c        stored in dbiatx(.,m) to get value of  (m-1)st  derivative of
c        i-th b-spline (of interest here) at  x , and store in
c        dbiatx(i,m). storage of this value over the value of a b-spline
c        of order m there is safe since the remaining b-spline derivat-
c        ive of the same order do not use this value due to the fact
c        that  a(j,i) = 0  for j .lt. i .
   30    do 40 i=1,k
            sum = 0.
            jlow = max0(i,m)
            do 35 j=jlow,k
   35          sum = a(j,i)*dbiatx(j,m) + sum
   40       dbiatx(i,m) = sum
   99 return
      end

      subroutine VRbsplvb ( t, lent,jhigh, index, x, left, biatx )
      implicit none
c     -------------

calculates the value of all possibly nonzero b-splines at  x  of order
c
c               jout  =  dmax( jhigh , (j+1)*(index-1) )
c
c  with knot sequence  t .
c
c******  i n p u t  ******
c  t.....knot sequence, of length  left + jout  , assumed to be nonde-
c        creasing.  a s s u m p t i o n . . . .
c                       t(left)  .lt.  t(left + 1)   .
c   d i v i s i o n  b y  z e r o  will result if  t(left) = t(left+1)
c  jhigh,
c  index.....integers which determine the order  jout = max(jhigh,
c        (j+1)*(index-1))  of the b-splines whose values at  x  are to
c        be returned.  index  is used to avoid recalculations when seve-
c        ral columns of the triangular array of b-spline values are nee-
c        ded (e.g., in  VRbval  or in  VRbsplvd ). precisely,
c                     if  index = 1 ,
c        the calculation starts from scratch and the entire triangular
c        array of b-spline values of orders 1,2,...,jhigh  is generated
c        order by order , i.e., column by column .
c                     if  index = 2 ,
c        only the b-spline values of order  j+1, j+2, ..., jout  are ge-
c        nerated, the assumption being that  biatx , j , deltal , deltar
c        are, on entry, as they were on exit at the previous call.
c           in particular, if  jhigh = 0, then  jout = j+1, i.e., just
c        the next column of b-spline values is generated.
c
c  w a r n i n g . . .  the restriction   jout .le. jmax (= 20)  is im-
c        posed arbitrarily by the dimension statement for  deltal  and
c        deltar  below, but is  n o w h e r e  c h e c k e d  for .
c
c  x.....the point at which the b-splines are to be evaluated.
c  left.....an integer chosen (usually) so that
c                  t(left) .le. x .le. t(left+1)  .
c
c******  o u t p u t  ******
c  biatx.....array of length  jout , with  biatx(i)  containing the val-
c        ue at  x  of the polynomial of order  jout  which agrees with
c        the b-spline  b(left-jout+i,jout,t)  on the interval (t(left),
c        t(left+1)) .
c
c******  m e t h o d  ******
c  the recurrence relation
c
c                       x - t(i)              t(i+j+1) - x
c     b(i,j+1)(x)  =  -----------b(i,j)(x) + ---------------b(i+1,j)(x)
c                     t(i+j)-t(i)            t(i+j+1)-t(i+1)
c
c  is used (repeatedly) to generate the (j+1)-vector  b(left-j,j+1)(x),
c  ...,b(left,j+1)(x)  from the j-vector  b(left-j+1,j)(x),...,
c  b(left,j)(x), storing the new values in  biatx  over the old. the
c  facts that
c            b(i,1) = 1  if  t(i) .le. x .lt. t(i+1)
c  and that
c            b(i,j)(x) = 0  unless  t(i) .le. x .lt. t(i+j)
c  are used. the particular organization of the calculations follows al-
c  gorithm  (8)  in chapter x of the text.
c

C Arguments
      integer lent, jhigh, index, left
      double precision t(lent),x, biatx(jhigh)
c     dimension     t(left+jout), biatx(jout)
c     -----------------------------------
c current fortran standard makes it impossible to specify the length of
c  t  and of  biatx  precisely without the introduction of otherwise
c  superfluous additional arguments.

C Local Variables
      integer jmax
      parameter(jmax = 20)
      integer i,j,jp1
      double precision deltal(jmax), deltar(jmax),saved,term

      data j/1/
      save j,deltal,deltar !(valid in fortran 77)
c
                                        go to (10,20), index
   10 j = 1
      biatx(1) = 1e0
      if (j .ge. jhigh)                 go to 99
c
   20    jp1 = j + 1
         deltar(j) = t(left+j) - x
         deltal(j) = x - t(left+1-j)
         saved = 0e0
         do 26 i=1,j
            term = biatx(i)/(deltar(i) + deltal(jp1-i))
            biatx(i) = saved + deltar(i)*term
   26       saved = deltal(jp1-i)*term
         biatx(jp1) = saved
         j = jp1
         if (j .lt. jhigh)              go to 20
c
   99                                   return
      end

      double precision function VRbval(t,lent,bcoef,n,k,x,jderiv)
      implicit none

calls  interv
c
calculates value at  x	of  jderiv-th derivative of spline from b-repr.
c  the spline is taken to be continuous from the right.
c
c******	 i n p u t ******
c  t, bcoef, n, k......forms the b-representation of the spline	 f  to
c	 be evaluated. specifically,
c  t.....knot sequence, of length  n+k, assumed nondecreasing.
c  bcoef.....b-coefficient sequence, of length	n .
c  n.....length of  bcoef  and dimension of s(k,t),
c	 a s s u m e d	positive .
c  k.....order of the spline .
c
c  w a r n i n g . . .	 the restriction  k .le. kmax (=20)  is imposed
c	 arbitrarily by the dimension statement for  aj, dm, dm	 below,
c	 but is	 n o w h e r e	c h e c k e d  for.
c
c  x.....the point at which to evaluate .
c  jderiv.....integer giving the order of the derivative to be evaluated
c	 a s s u m e d	to be zero or positive.
c
c******	 o u t p u t  ******
c  VRbval.....the value of the (jderiv)-th derivative of  f  at	 x .
c
c******	 m e t h o d  ******
c     the nontrivial knot interval  (t(i),t(i+1))  containing  x  is lo-
c  cated with the aid of  interv . the	k  b-coeffs of	f  relevant for
c  this interval are then obtained from	 bcoef (or taken to be zero if
c  not explicitly available) and are then differenced  jderiv  times to
c  obtain the b-coeffs of  (d**jderiv)f	 relevant for that interval.
c  precisely, with  j = jderiv, we have from x.(12) of the text that
c
c     (d**j)f  =  sum ( bcoef(.,j)*b(.,k-j,t) )
c
c  where
c		    / bcoef(.),			    ,  j .eq. 0
c		    /
c    bcoef(.,j)	 =  / bcoef(.,j-1) - bcoef(.-1,j-1)
c		    / ----------------------------- ,  j .gt. 0
c		    /	 (t(.+k-j) - t(.))/(k-j)
c
c     then, we use repeatedly the fact that
c
c    sum ( a(.)*b(.,m,t)(x) )  =  sum ( a(.,x)*b(.,m-1,t)(x) )
c  with
c		  (x - t(.))*a(.) + (t(.+m-1) - x)*a(.-1)
c    a(.,x)  =	  ---------------------------------------
c		  (x - t(.))	  + (t(.+m-1) - x)
c
c  to write  (d**j)f(x)	 eventually as a linear combination of b-splines
c  of order  1 , and the coefficient for  b(i,1,t)(x)  must then
c  be the desired number  (d**j)f(x). (see x.(17)-(19) of text).
c
C Arguments
      integer lent, n,k, jderiv
      DOUBLE precision t(lent),bcoef(n),x
c     dimension t(n+k)
c  current fortran standard makes it impossible to specify the length of
c  t  precisely without the introduction of otherwise superfluous
c  additional arguments.

C Local Variables
      integer kmax
      parameter(kmax = 20)

      DOUBLE precision aj(kmax),dm(kmax),dp(kmax),fkmj

      integer i,ilo,imk,j,jc,jcmin,jcmax,jj,km1,kmj,mflag,nmi,
     &	   jdrvp1


      VRbval = 0.
      if (jderiv .ge. k)		go to 99
c
c  *** find  i	s.t.  1 .le. i .lt. n+k	 and  t(i) .lt. t(i+1) and
c      t(i) .le. x .lt. t(i+1) . if no such i can be found,  x	lies
c      outside the support of  the spline  f  and  VRbval = 0.
c      (the asymmetry in this choice of	 i  makes  f  rightcontinuous)
      if( (x.ne.t(n+1)) .or. (t(n+1).ne.t(n+k)) )  go to 700
      i = n
					go to 701
  700 call VRint ( t, n+k, x, i, mflag )
      if (mflag .ne. 0)			go to 99
  701 continue
c  *** if k = 1 (and jderiv = 0), VRbval = bcoef(i).
      km1 = k - 1
      if (km1 .gt. 0)			go to 1
      VRbval = bcoef(i)
					go to 99
c
c  *** store the k b-spline coefficients relevant for the knot interval
c     (t(i),t(i+1)) in aj(1),...,aj(k) and compute dm(j) = x - t(i+1-j),
c     dp(j) = t(i+j) - x, j=1,...,k-1 . set any of the aj not obtainable
c     from input to zero. set any t.s not obtainable equal to t(1) or
c     to t(n+k) appropriately.
    1 jcmin = 1
      imk = i - k
      if (imk .ge. 0)			go to 8
      jcmin = 1 - imk
      do 5 j=1,i
    5	 dm(j) = x - t(i+1-j)
      do 6 j=i,km1
	 aj(k-j) = 0.
    6	 dm(j) = dm(i)
					go to 10
    8 do 9 j=1,km1
    9	 dm(j) = x - t(i+1-j)
c
   10 jcmax = k
      nmi = n - i
      if (nmi .ge. 0)			go to 18
      jcmax = k + nmi
      do 15 j=1,jcmax
   15	 dp(j) = t(i+j) - x
      do 16 j=jcmax,km1
	 aj(j+1) = 0.
   16	 dp(j) = dp(jcmax)
					go to 20
   18 do 19 j=1,km1
C the following if() happens; e.g. in   pp <- predict(cars.spl, xx)
c- 	 if( (i+j) .gt.lent) write(6,9911) i+j,lent
c-  9911	 format(' i+j, lent ',2(i6,1x))
	 dp(j) = t(i+j) - x
   19 continue

c
   20 do 21 jc=jcmin,jcmax
   21	 aj(jc) = bcoef(imk + jc)
c
c		*** difference the coefficients	 jderiv	 times.
      if (jderiv .eq. 0)		go to 30
      do 23 j=1,jderiv
	 kmj = k-j
	 fkmj = dble(kmj)
	 ilo = kmj
	 do 23 jj=1,kmj
	    aj(jj) = ((aj(jj+1) - aj(jj))/(dm(ilo) + dp(jj)))*fkmj
   23	    ilo = ilo - 1
c
c  *** compute value at	 x  in (t(i),t(i+1)) of jderiv-th derivative,
c     given its relevant b-spline coeffs in aj(1),...,aj(k-jderiv).

   30 if (jderiv .eq. km1)		go to 39
      jdrvp1 = jderiv + 1
      do 33 j=jdrvp1,km1
	 kmj = k-j
	 ilo = kmj
	 do 33 jj=1,kmj
	    aj(jj) = (aj(jj+1)*dm(ilo) + aj(jj)*dp(jj))/(dm(ilo)+dp(jj))
   33	    ilo = ilo - 1
   39 VRbval = aj(1)
c
   99 return
      end

      subroutine VRint ( xt, lxt, x, left, mflag )
      implicit none

computes  left = max( i ; 1 .le. i .le. lxt  .and.  xt(i) .le. x )  .
c
c******	 i n p u t  ******
c  xt.....a double sequence, of length	lxt , assumed to be nondecreasing
c  lxt.....number of terms in the sequence  xt .
c  x.....the point whose location with respect to the sequence	xt  is
c	 to be determined.
c
c******	 o u t p u t  ******
c  left, mflag.....both integers, whose value is
c
c   1	  -1	  if		   x .lt.  xt(1)
c   i	   0	  if   xt(i)  .le. x .lt. xt(i+1)
c  lxt	   1	  if  xt(lxt) .le. x
c
c	 in particular,	 mflag = 0 is the 'usual' case.	 mflag .ne. 0
c	 indicates that	 x  lies outside the halfopen interval
c	 xt(1) .le. y .lt. xt(lxt) . the asymmetric treatment of the
c	 interval is due to the decision to make all pp functions cont-
c	 inuous from the right.
c
c******	 m e t h o d  ******
c  the program is designed to be efficient in the common situation that
c  it is called repeatedly, with  x  taken from an increasing or decrea-
c  sing sequence. this will happen, e.g., when a pp function is to be
c  graphed. the first guess for	 left  is therefore taken to be the val-
c  ue returned at the previous call and stored in the  l o c a l  varia-
c  ble	ilo . a first check ascertains that  ilo .lt. lxt (this is nec-
c  essary since the present call may have nothing to do with the previ-
c  ous call). then, if	xt(ilo) .le. x .lt. xt(ilo+1), we set  left =
c  ilo	and are done after just three comparisons.
c     otherwise, we repeatedly double the difference  istep = ihi - ilo
c  while also moving  ilo  and	ihi  in the direction of  x , until
c		       xt(ilo) .le. x .lt. xt(ihi) ,
c  after which we use bisection to get, in addition, ilo+1 = ihi .
c  left = ilo  is then returned.
c
      integer left,lxt,mflag,	ihi,ilo,istep,middle
      double precision x,xt(lxt)
      data ilo /1/
c     save ilo	(a valid fortran statement in the new 1977 standard)
      ihi = ilo + 1
      if (ihi .lt. lxt)			go to 20
	 if (x .ge. xt(lxt))		go to 110
	 if (lxt .le. 1)		go to 90
	 ilo = lxt - 1
	 ihi = lxt
c
   20 if (x .ge. xt(ihi))		go to 40
      if (x .ge. xt(ilo))		go to 100
c
c	       **** now x .lt. xt(ilo) . decrease  ilo	to capture  x .
   30 istep = 1
   31	 ihi = ilo
	 ilo = ihi - istep
	 if (ilo .le. 1)		go to 35
	 if (x .ge. xt(ilo))		go to 50
	 istep = istep*2
					go to 31
   35 ilo = 1
      if (x .lt. xt(1))			go to 90
					go to 50
c	       **** now x .ge. xt(ihi) . increase  ihi	to capture  x .
   40 istep = 1
   41	 ilo = ihi
	 ihi = ilo + istep
	 if (ihi .ge. lxt)		go to 45
	 if (x .lt. xt(ihi))		go to 50
	 istep = istep*2
					go to 41
   45 if (x .ge. xt(lxt))		go to 110
      ihi = lxt
c
c	    **** now xt(ilo) .le. x .lt. xt(ihi) . narrow the interval.
   50 middle = (ilo + ihi)/2
      if (middle .eq. ilo)		go to 100
c     note. it is assumed that middle = ilo in case ihi = ilo+1 .
      if (x .lt. xt(middle))		go to 53
	 ilo = middle
					go to 50
   53	 ihi = middle
					go to 50
c**** set output and return.
   90 mflag = -1
      left = 1
					return
  100 mflag = 0
      left = ilo
					return
  110 mflag = 1
      left = lxt
					return
      end
C Output from Public domain Ratfor, version 1.0
      subroutine VRsinerp(abd,ld4,nk,p1ip,p2ip,ldnk,flag)
c
C Purpose :  Computes Inner Products between columns of L(-1)
C	     where L = abd is a Banded Matrix with 3 subdiagonals

C The algorithm works in two passes:
C
C		Pass 1 computes (cj,ck) k=j,j-1,j-2,j-3 ,j=nk, .. 1
C		Pass 2 computes (cj,ck) k<=j-4  (If flag == 1 ).
C
C		A refinement of Elden's trick is used.
      implicit none
c Args
      integer ld4,nk,ldnk,flag
      DOUBLE precision abd(ld4,nk),p1ip(ld4,nk), p2ip(ldnk,nk)
c Locals
      integer i,j,k
      DOUBLE precision  wjm3(3),wjm2(2),wjm1(1),c0,c1,c2,c3
C
C Pass 1
      wjm3(1)=0d0
      wjm3(2)=0d0
      wjm3(3)=0d0
      wjm2(1)=0d0
      wjm2(2)=0d0
      wjm1(1)=0d0
      do 100 i=1,nk 
         j=nk-i+1
         c0 = 1e0/abd(4,j)
         if(j.le.nk-3)then
            c1 = abd(1,j+3)*c0
            c2 = abd(2,j+2)*c0
            c3 = abd(3,j+1)*c0 
         else if(j.eq.nk-2)then
            c1 = 0d0
            c2 = abd(2,j+2)*c0
            c3 = abd(3,j+1)*c0 
         else if(j.eq.nk-1)then
            c1 = 0d0
            c2 = 0d0
            c3 = abd(3,j+1)*c0 
         else if(j.eq.nk)then
            c1 = 0d0
            c2 = 0d0
            c3 = 0d0
         endif
         p1ip(1,j) = 0d0- (c1*wjm3(1)+c2*wjm3(2)+c3*wjm3(3))
         p1ip(2,j) = 0d0- (c1*wjm3(2)+c2*wjm2(1)+c3*wjm2(2))
         p1ip(3,j) = 0d0- (c1*wjm3(3)+c2*wjm2(2)+c3*wjm1(1))
         p1ip(4,j) = c0**2 + c1**2*wjm3(1) + 2d0*c1*c2*wjm3(2)+
     &        2d0*c1*c3*wjm3(3) + c2**2*wjm2(1) + 2d0*c2*c3*wjm2(2) +
     &        c3**2*wjm1(1)
         wjm3(1)=wjm2(1) 
         wjm3(2)=wjm2(2) 
         wjm3(3)=p1ip(2,j)
         wjm2(1)=wjm1(1) 
         wjm2(2)=p1ip(3,j)
         wjm1(1)=p1ip(4,j)
 100  continue

      if(flag.ne.0)then

C     ____ Pass 2 _____
         
C     Compute p2ip
         do 120 i=1,nk 
            j=nk-i+1
C           for(k=1;k<=4 & j+k-1<=nk;k=k+1) { p2ip(.) = .. }:
            do 160 k=1,4
               if(j+k-1 .gt. nk)goto 120
               p2ip(j,j+k-1) = p1ip(5-k,j) 
 160        continue
 120     continue
         
         do 170 i=1,nk 
            j=nk-i+1
c           for(k=j-4;k>=1;k=k-1){
            if(j-4 .ge. 1) then
               do 210 k= j-4,1, -1
                  c0 = 1d0/abd(4,k) 
                  c1 = abd(1,k+3)*c0
                  c2 = abd(2,k+2)*c0 
                  c3 = abd(3,k+1)*c0
                  p2ip(k,j)= 0d0 - ( c1*p2ip(k+3,j) + c2*p2ip(k+2,j) + 
     &                 c3*p2ip(k+1,j) ) 
 210           continue
            endif
 170     continue
      endif
      return
      end

