.\" file spatial/correlogram.d copyright (C) 1994-9 W. N. Venables and B. D. Ripley
.\"
.BG
.FN correlogram
.TL
Compute Spatial Correlograms
.DN
Compute spatial correlograms of spatial data or residuals.
.CS
correlogram(krig, nint, plotit=T,  ...)
.RA
.AG krig
trend-surface or kriging object with columns `x', `y', and `z'
.AG nint
number of bins used
.OA
.AG plotit
logical for plotting
.AG ...
parameters for the plot
.RT
`x' and `y' coordinates of the correlogram, and `cnt', the number of pairs
averaged per bin.
.SE
Plots the correlogram if `plotit = T'.
.DT
Divides range of data into `nint' bins, and computes the covariance for
pairs with separation in each bin, then divides by the variance.
Returns results for bins with 6 or more pairs.
.SA
`variogram'
.EX
topo.kr <- surf.ls(2, topo)
correlogram(topo.kr, 25)
d <- seq(0, 7, 0.1)
lines(d, expcov(d, 0.7))
.KW spatial
.WR
